#!/usr/bin/perl -w

use strict;

use CGI;
use File::Find;

use IO::Handle;
STDOUT->autoflush(1);

my $q = new CGI;
my $path = $q->param('path');
my $result = $q->param('result');
my $before_ext = $q->param('before_ext');
my $after_ext = $q->param('after_ext');

print $q->header( -charset => "utf-8" );

eval { require Image::Magick; };
if ($@) {
    warn "$@";
    exit;
}

print <<EOF;
<style>
body {
    margin: 20px;
    font-family: Verdana,Arial,sans-serif;
    font-size: 18px;
}
h1 {
    font-size:140%;
    font-weight: normal;
    margin-bottom: 30px;
}
h2 {
    border-left: 5px solid #000;
    width: 620px;
    margin: -5px 0;
    padding: 3px 0 3px 7px;
}
dl {
    width: 350px;
}
dt {
    width: 150px;
    clear: left;
    float: left;
}
dd {
    margin-left:0;
    width: 150px;
    display: inline-block;
}
dt, dd {
    margin-bottom: 5px;
}
input[name=path] {
    width: 500px;
}
input[type=text] {
    font-size: 100%;
}
#send {
    width: 150px;
    padding: 5px;
    font-size: 120%;
}
#clear {
    width: 120px;
    padding: 5px;
    font-size: 120%;
}
.attn {
    color: #e50003;
}
</style>
<h1>画像形式一括変換ツール</h1>
<form method="post" action="./changeImageType.cgi">
  <input type="hidden" name="result" value="1" />
  <dl>
    <dt>ディレクトリ</dt>
    <dd><input type="text" name="path" value="$path" /></dd>
    <dt>変換前の拡張子</dt>
    <dd><input type="text" name="before_ext" value="$before_ext" /></dd>
    <dt>変換後の拡張子</dt>
    <dd><input type="text" name="after_ext" value="$after_ext" /></dd>
  </dl>
  <input id="send" type="submit" value="実行" />
  <input id="clear" type="reset" value="クリア" />
</form>
EOF

my $flag = 0;
if ( $result ) {
    if ( !$path ) {
        print '<span class="attn">パスが設定されていません。</span><br />' ;
        $flag = 1;
    }
    if ( !$before_ext ) {
        print '<span class="attn">変更前の拡張子が設定されていません。</span><br />';
        $flag = 1;
    }
    if ( !$after_ext) {
        print '<span class="attn">変更後の拡張子が設定されていません。</span><br />';
        $flag = 1;
    }
}
exit if $flag;

find( { wanted => \&filter, no_chdir => 1 }, $path );

sub filter {
    return unless (/.*\.$before_ext$/ and -e );
    my $name;
    my $dir;
    eval {
        $name = $File::Find::name;
        $dir  = $File::Find::dir;
        return if ( $name !~ /\.$before_ext$/ );

        my $img = Image::Magick->new;
        $img->Read($name);
        my $size = $img->Get("filesize");
        (my $after = $name) =~ s/\.$before_ext$/.$after_ext/;
        $img->Write($after);

        my $after_img = Image::Magick->new;
        $after_img->Read($after);
        my $after_size = $after_img->Get("filesize");
        print "$name（${size}byte） → $after（${after_size}byte）<br />";
    };
    if ($@) {
        warn "$name : $@";
    }
}
